package VistaControlador;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Logica.Gestion;
import Logica.Transaccion;

public class Controlador implements ActionListener,ChangeListener{

	private Vista vista;
	public Controlador(Vista vista) {
		this.vista=vista;
		this.aniadirListeners();
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand().equals(this.vista.boton.getActionCommand())) {
			String nombre=JOptionPane.showInputDialog("Introduce un nuevo gasto o ingreso");
			if(nombre.equals("")) {
				JOptionPane.showMessageDialog(null, "Debe introducir algo", "error", JOptionPane.WARNING_MESSAGE);
				return;
			}
			String dinero=JOptionPane.showInputDialog("Introduce a cuanto asciende");
			if(dinero.equals("")) {
				JOptionPane.showMessageDialog(null, "Debe introducir algo", "error", JOptionPane.WARNING_MESSAGE);
				return;
			}
			
			try {
				this.vista.aniadirElemento(nombre, Integer.parseInt(dinero));
				this.vista.menu.total.setText(String.valueOf(Gestion.getTotal()));
				this.vista.menu.total.revalidate();
				this.vista.menu.total.repaint();
				this.aniadirListeners();
			}catch (NumberFormatException ex) {
				JOptionPane.showMessageDialog(null, "Debe introducir un numero", "error", JOptionPane.WARNING_MESSAGE);
			}
		}else {
			JCheckBox pulsado=(JCheckBox)e.getSource();
			for(int i=0;i<vista.gestiones.getElementos().size();i++) {
				if(vista.gestiones.getElementos().get(i).toString().equals(pulsado.getText())) {
					vista.gestiones.alterarVisibilidad(!vista.gestiones.getElementos().get(i).getVisivilidad(), i);
					this.vista.menu.total.setText(String.valueOf(Gestion.getTotal()));
					this.vista.menu.total.revalidate();
					this.vista.menu.total.repaint();
				}
			}
		}
		
		
	}
	
	@Override
	public void stateChanged(ChangeEvent e) {
		// TODO Auto-generated method stub
		JCheckBox pulsado=(JCheckBox)e.getSource();
		for(Transaccion transaaccio:vista.gestiones.getElementos()) {
			if(transaaccio.toString().equals(pulsado.getText())) {
				transaaccio.alterarVisivilidad(false);
			}
		}
	}
	
	private void aniadirListeners() {
		vista.boton.addActionListener(this);
		for(JCheckBox check:this.vista.transacciones) {
			check.addActionListener(this);
		}
	}
	
}
